"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _getProviderContent = _interopRequireDefault(require("./utils/getProviderContent"));

var _getModelContent = _interopRequireDefault(require("./utils/getModelContent"));

var _getExportContent = _interopRequireDefault(require("./utils/getExportContent"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = function _default(api) {
  var paths = api.paths,
      findJS = api.findJS; // 注册 getInitialState 方法

  api.addRuntimePluginKey('getInitialState');
  api.writeTmpFile((0, _path.join)(_constants.DIR_NAME, 'Provider.tsx'), _getProviderContent.default); // Add provider to prevent render

  api.addRuntimePlugin((0, _path.join)(__dirname, './runtime'));
  api.onGenerateFiles(function () {
    var entryFile = findJS((0, _path.join)(paths.absSrcPath, 'app'));

    if (entryFile) {
      var relEntryFile = (0, _path.relative)(paths.cwd, entryFile);
      api.writeTmpFile(_constants.RELATIVE_MODEL_PATH, (0, _getModelContent.default)(relEntryFile));
      api.writeTmpFile(_constants.RELATIVE_EXPORT_PATH, (0, _getExportContent.default)(_constants.RELATIVE_MODEL));
    } else {
      api.log.warn('[@umijs/plugin-initial-state]: 检测到 @umijs/plugin-initial-state 插件已经开启，但是不存在 app.ts/js 入口文件。');
    }
  });
  api.addUmiExports([{
    exportAll: true,
    source: api.winPath((0, _path.join)(api.paths.absTmpDirPath, _constants.RELATIVE_EXPORT))
  }]);
  api.register('addExtraModels', function () {
    return [{
      absPath: (0, _path.join)(paths.absTmpDirPath, _constants.RELATIVE_MODEL_PATH),
      namespace: '@@initialState'
    }];
  });
};

exports.default = _default;